# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for license information.
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------

from enum import Enum
from azure.core import CaseInsensitiveEnumMeta


class ActionType(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Enum. Indicates the action type. "Internal" refers to actions that are for internal only APIs."""

    INTERNAL = "Internal"


class ArcSettingAggregateState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Aggregate state of Arc agent across the nodes in this HCI cluster."""

    NOT_SPECIFIED = "NotSpecified"
    ERROR = "Error"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"
    CONNECTED = "Connected"
    DISCONNECTED = "Disconnected"
    DELETED = "Deleted"
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    MOVING = "Moving"
    PARTIALLY_SUCCEEDED = "PartiallySucceeded"
    PARTIALLY_CONNECTED = "PartiallyConnected"
    IN_PROGRESS = "InProgress"


class AvailabilityType(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Indicates the way the update content can be downloaded."""

    LOCAL = "Local"
    ONLINE = "Online"
    NOTIFY = "Notify"


class ClusterNodeType(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Type of the cluster node hardware."""

    FIRST_PARTY = "FirstParty"
    THIRD_PARTY = "ThirdParty"


class CreatedByType(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The type of identity that created the resource."""

    USER = "User"
    APPLICATION = "Application"
    MANAGED_IDENTITY = "ManagedIdentity"
    KEY = "Key"


class DiagnosticLevel(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Desired level of diagnostic data emitted by the cluster."""

    OFF = "Off"
    BASIC = "Basic"
    ENHANCED = "Enhanced"


class ExtensionAggregateState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Aggregate state of Arc Extensions across the nodes in this HCI cluster."""

    NOT_SPECIFIED = "NotSpecified"
    ERROR = "Error"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"
    CONNECTED = "Connected"
    DISCONNECTED = "Disconnected"
    DELETED = "Deleted"
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    MOVING = "Moving"
    PARTIALLY_SUCCEEDED = "PartiallySucceeded"
    PARTIALLY_CONNECTED = "PartiallyConnected"
    IN_PROGRESS = "InProgress"


class ImdsAttestation(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """IMDS attestation status of the cluster."""

    DISABLED = "Disabled"
    ENABLED = "Enabled"


class ManagedServiceIdentityType(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Type of managed service identity (where both SystemAssigned and UserAssigned types are
    allowed).
    """

    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


class NodeArcState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """State of Arc agent in this node."""

    NOT_SPECIFIED = "NotSpecified"
    ERROR = "Error"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"
    CONNECTED = "Connected"
    DISCONNECTED = "Disconnected"
    DELETED = "Deleted"
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    MOVING = "Moving"


class NodeExtensionState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """State of Arc Extension in this node."""

    NOT_SPECIFIED = "NotSpecified"
    ERROR = "Error"
    SUCCEEDED = "Succeeded"
    CANCELED = "Canceled"
    FAILED = "Failed"
    CONNECTED = "Connected"
    DISCONNECTED = "Disconnected"
    DELETED = "Deleted"
    CREATING = "Creating"
    UPDATING = "Updating"
    DELETING = "Deleting"
    MOVING = "Moving"


class Origin(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """The intended executor of the operation; as in Resource Based Access Control (RBAC) and audit
    logs UX. Default value is "user,system".
    """

    USER = "user"
    SYSTEM = "system"
    USER_SYSTEM = "user,system"


class ProvisioningState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Provisioning state of the ArcSetting proxy resource."""

    SUCCEEDED = "Succeeded"
    FAILED = "Failed"
    CANCELED = "Canceled"
    ACCEPTED = "Accepted"
    PROVISIONING = "Provisioning"


class SoftwareAssuranceIntent(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Customer Intent for Software Assurance Benefit."""

    ENABLE = "Enable"
    DISABLE = "Disable"


class SoftwareAssuranceStatus(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Status of the Software Assurance for the cluster."""

    ENABLED = "Enabled"
    DISABLED = "Disabled"


class State(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """State of the update as it relates to this stamp."""

    HAS_PREREQUISITE = "HasPrerequisite"
    OBSOLETE = "Obsolete"
    READY = "Ready"
    NOT_APPLICABLE_BECAUSE_ANOTHER_UPDATE_IS_IN_PROGRESS = "NotApplicableBecauseAnotherUpdateIsInProgress"
    PREPARING = "Preparing"
    INSTALLING = "Installing"
    INSTALLED = "Installed"
    PREPARATION_FAILED = "PreparationFailed"
    INSTALLATION_FAILED = "InstallationFailed"
    INVALID = "Invalid"
    RECALLED = "Recalled"
    DOWNLOADING = "Downloading"
    DOWNLOAD_FAILED = "DownloadFailed"
    HEALTH_CHECKING = "HealthChecking"
    HEALTH_CHECK_FAILED = "HealthCheckFailed"
    READY_TO_INSTALL = "ReadyToInstall"
    SCAN_IN_PROGRESS = "ScanInProgress"
    SCAN_FAILED = "ScanFailed"


class Status(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Status of the cluster agent."""

    NOT_YET_REGISTERED = "NotYetRegistered"
    CONNECTED_RECENTLY = "ConnectedRecently"
    NOT_CONNECTED_RECENTLY = "NotConnectedRecently"
    DISCONNECTED = "Disconnected"
    ERROR = "Error"


class UpdateRunPropertiesState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """State of the update run."""

    UNKNOWN = "Unknown"
    SUCCEEDED = "Succeeded"
    IN_PROGRESS = "InProgress"
    FAILED = "Failed"


class UpdateSummariesPropertiesState(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Overall update state of the stamp."""

    UNKNOWN = "Unknown"
    APPLIED_SUCCESSFULLY = "AppliedSuccessfully"
    UPDATE_AVAILABLE = "UpdateAvailable"
    UPDATE_IN_PROGRESS = "UpdateInProgress"
    UPDATE_FAILED = "UpdateFailed"
    NEEDS_ATTENTION = "NeedsAttention"
    PREPARATION_IN_PROGRESS = "PreparationInProgress"
    PREPARATION_FAILED = "PreparationFailed"


class WindowsServerSubscription(str, Enum, metaclass=CaseInsensitiveEnumMeta):
    """Desired state of Windows Server Subscription."""

    DISABLED = "Disabled"
    ENABLED = "Enabled"
